package dags;

public class DagerTester{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  static String[] dfds;
  static String[] arities;
  static int[][] parentsMulti;  

// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
    Dager.construct(args[0],args[1]);
    int[][] dag = Dager.sortMulti();
    dfds = Dager.dfds;
    arities = Dager.arities;
    parentsMulti = Dager.parentsMulti;
    display(dag);
    DagGrapher dg = new DagGrapher(dag);
    String L = dg.graphMulti();
    System.out.println(L);
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  static void display(int[][] dag) {
    String s = "0," + dfds[dag[0][0]] + ":" + arities[dag[0][0]];
    System.out.println(s);
    for (int i = 1; i < dag.length; i++) {
      s = "";
      for (int j = 0; j < dag[i].length; j++) {
        s += Integer.toString(dag[i][j]) + ",";
        s += dfds[dag[i][j]] + ":";
        s += arities[dag[i][j]] + ",";
        for (int k = 0; k < parentsMulti[dag[i][j]].length; k++) {
          s += Integer.toString(parentsMulti[dag[i][j]][k]);
        }
        if (j!=dag[i].length-1) {s += "  ";}
      }
      System.out.println(s);
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 