package expandDG;

public class Qbubble{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  String name;
  
  int bornAt;
  int nextChance;
  boolean changer = false;
  boolean closedYet = false;
  boolean justClosed = false;
  boolean scopeStarted = false;
  boolean openScope = false;
  boolean maybeHaveToWait = false;
  boolean waiting = false;
  boolean dead = false;
  
  public static boolean verbose = false;
  
// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Qbubble(int p) {
    bornAt = p;
    if (verbose) {System.out.println("Born.");}
  }
  
  public Qbubble(int p, String n) {
    bornAt = p;
    name = n;
    if (verbose) {System.out.println(name+":Born.");}
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------
  
  int change() {if (changer) {return 1;} else {return 0;} }
  
  int codeCall(int p, int c) {
    int dead = 0;
    
    if (!closedYet && c==1 && p==bornAt-1) {
      closedYet = true;
      justClosed = true;
      if (verbose) {vox(1);}
    }
    
    else if (justClosed) {
      justClosed = false;
      if (c==1) {dead = 1; if (verbose) {vox(0);}}
      if (c==2) {scopeStarted = true; openScope = true; if (verbose) {vox(2);}}
      if (c==3) {scopeStarted = true; openScope = true; if (verbose) {vox(2);}}
      if (c==0) {maybeHaveToWait = true; nextChance = p-1;}
    }
    
    else if (maybeHaveToWait) {
      maybeHaveToWait = false;
      if (c==2) {waiting = true; if (verbose) {vox(3);}}
      else if (c==1) {dead = 1; if (verbose) {vox(0);}}
      else {scopeStarted = true; openScope = false; if (verbose) {vox(4);}}
    }
    
    else if (waiting && c==1 && p==nextChance) {
      waiting = false;
      justClosed = true;
      if (verbose) {vox(1);}
    }
    
    else if (scopeStarted) {
      if (c==1 && openScope && p==bornAt-2) {dead = 1; if (verbose) {vox(0);}}
      if (c==1 && !openScope && p==bornAt-1) {dead = 1; if (verbose) {vox(0);}}
    }
    
    if (dead==1) {this.dead = true;}
    if (this.dead) {
      return change();
    } else {
      return 0;
    }
  }
  
  void vox(int n) {
    boolean screen = true;
    if (screen) {
      switch (n) {
        case 0: System.out.println(name+":Dead."); break;
        case 1: System.out.println(name+":Just closed."); break;
        case 2: System.out.println(name+":Started open scope."); break;
        case 3: System.out.println(name+":Waiting."); break;
        case 4: System.out.println(name+":Started closed scope."); break;
      }
    } else {
    }
  }
  
// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 