package graphs;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

public class GraphViewer extends JPanel {

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  
  static GraphViewer g;

// ----------------------------------------------------------------------------
// Main
// ----------------------------------------------------------------------------

  public static void main(String[] args) {
  //Schedule a job for the event-dispatching thread:
  //creating and showing this application's GUI.
    if (args.length != 1) {
      System.out.println("Usage: java GraphViewer application\n" +
                         "where application is chosen from:\n" +
                         "1. kmap");
    } else {
      final String app = args[0];
      javax.swing.SwingUtilities.invokeLater(new Runnable() {
        public void run() {
          createAndShowGUI(app);
        }
      });
    }
  }

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public GraphViewer() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  void setUpFrame(JFrame f) {
  }
  
  static void createAndShowGUI(String app) {
  /**
   * Create the GUI and show it.  For thread safety,
   * this method should be invoked from the
   * event-dispatching thread.
   */
      //Create and set up the window.
      JFrame frame = new JFrame("GraphViewer");
      frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      
      //Create and set up the content pane.
      g = new GraphViewer();
      if (app.equals("kmap")) {
        g = new Kmap();
      }
      g.setUpFrame(frame);
      
      //Display the window.
      frame.pack();
      frame.setVisible(true);
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 