package lpt2dzfc;

public class Bterm{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------

  public FormulaBuilder aterm;
  private FormulaBuilder[][] evals = null;
  
  private Term tool = new Term();

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Bterm() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder output() {
    FormulaBuilder f = aterm;
    if (evals!=null) {
      for (int i = 0; i < evals.length; i++) {
        f = tool.evaluate(f,evals[i]);
      }
    }
    return f;
  }
  
  public void addEval(FormulaBuilder[] a) {
    if (evals==null) {
      evals = new FormulaBuilder[1][];
      evals[0] = a;
    } else {
      FormulaBuilder[][] b = new FormulaBuilder[evals.length+1][];
      System.arraycopy(evals,0,b,0,evals.length);
      b[evals.length] = a;
      evals = b;
    }
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 