package lpt2dzfc;

public class Tupler{

// ----------------------------------------------------------------------------
// Data
// ----------------------------------------------------------------------------
  

// ----------------------------------------------------------------------------
// Constructors
// ----------------------------------------------------------------------------

  public Tupler() {
  }

// ----------------------------------------------------------------------------
// Methods
// ----------------------------------------------------------------------------

  public FormulaBuilder pair(FormulaBuilder s, FormulaBuilder t) {
    FormulaBuilder f = new FormulaBuilder();
    f.addDef("\\varpi_{0}");
    f.addText("(");
    f.append(s);
    f.addText(",");
    f.append(t);
    f.addText(")");
    return f;
  }
  
  public FormulaBuilder tuple(FormulaBuilder[] a) {
    FormulaBuilder f = new FormulaBuilder();
    if (a==null) {
      a = new FormulaBuilder[0];
    }
    if (a.length < 2) {
      f.addText("Tuple needs at least 2 elements!");
    } else {
      if (a.length==2) {
        f = pair(a[0],a[1]);
      } else {
        FormulaBuilder[] b = new FormulaBuilder[a.length-1];
        b[0] = pair(a[0],a[1]);
        System.arraycopy(a,2,b,1,b.length-1);
        f = tuple(b);
      }
    }
    return f;
  }

// ----------------------------------------------------------------------------
}  // ----------------------------------------------------------------------
// ---------------------------------------------------------------------------- 