package util.arrapp;

public class Arrapp{

  public static String[] append(String[] a, String z) {
    if (a==null) {
      a = new String[1];
      a[0] = z;
    } else {
      String[] b = new String[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = z;
      a = b;
    }
    return a;
  }
  
  public static int[] append(int[] a, int z) {
    if (a==null) {
      a = new int[1];
      a[0] = z;
    } else {
      int[] b = new int[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = z;
      a = b;
    }
    return a;
  }
  
  public static byte[] append(byte[] a, byte z) {
    if (a==null) {
      a = new byte[1];
      a[0] = z;
    } else {
      byte[] b = new byte[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = z;
      a = b;
    }
    return a;
  }
  
  public static int[][] append(int[][] a, int[] z) {
    if (a==null) {
      a = new int[1][];
      a[0] = new int[z.length];
      System.arraycopy(z,0,a[0],0,z.length);
    } else {
      int[][] b = new int[a.length+1][];
      for (int i = 0; i < a.length; i++) {
        b[i] = new int[a[i].length];
        System.arraycopy(a[i],0,b[i],0,a[i].length);
      }
      b[a.length] = new int[z.length];
      System.arraycopy(z,0,b[a.length],0,z.length);
      a = b;
    }
    return a;
  }
  
  public static boolean[] append(boolean[] a, boolean z) {
    if (a==null) {
      a = new boolean[1];
      a[0] = z;
    } else {
      boolean[] b = new boolean[a.length+1];
      System.arraycopy(a,0,b,0,a.length);
      b[a.length] = z;
      a = b;
    }
    return a;
  }
  
  public static int[] union(int[] a, int z) {
    if (a==null) {
      a = new int[1];
      a[0] = z;
    } else {
      boolean present = false;
      for (int i = 0; i < a.length; i++) {
        present |= (a[i]==z);
      }
      if (!present) {
        a = append(a,z);
      }
    }
    return a;
  }
  
} 