package util.listreader;

public class LRtest {

  public static ListReader lr;

  public static void main(String[] args) {
    lr = new ListReader();
    lr.setListFileName(args[1]);
    int n = lr.initialize();
    System.out.println("Initialize return value: " + Integer.toString(n));
    if (args[0].equals("0")) {
      readTwice();
    } else if (args[0].equals("1")) {
      readAll();
    }
  }
  
  private static void readTwice() {
    String s = lr.read();
    System.out.println("First line: " + s);
    s = lr.read();
    System.out.println("Second line: " + s);
  }
  
  private static void readAll() {
    String[] a = lr.readAll();
    for (int i = 0; i < a.length; i++) {
      System.out.println("Line " + Integer.toString(i) + ": " + a[i]);
    }
  }
  
} 