package util.logkeeper;

import java.io.*;

public class LogKeeper {
  static String filename;
  static File file;
  static FileOutputStream out;
  static boolean printLogErrors = false;

  public static void setup(String f) {
    filename = f;
    try {
      file = new File(filename);
      out = new FileOutputStream(file);
    } catch(IOException e) {
      if (printLogErrors) {System.out.println("Log error 1.");}
    }
  }

  public static void record(String s) {
    try {
      String u = s + "\n";
      out.write(u.getBytes());
    } catch(IOException e) {
      if (printLogErrors) {System.out.println("Log error 2.");}
    }
  }

  public static void printLogErrors() {
    printLogErrors = true;
  }
}
